#include "router.h"
#include <cerrno>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <stdbool.h>
#include <sys/socket.h>
#include <unistd.h>
#include "ossl-setup.h"

void proxyToPort(int port, SSL *ssl){
    int sock = createSocketClient((char*) "127.0.0.1", port);
    bool socketopen=true;
    const int bufsize = 512;
    char ibuffer[bufsize+1];
    char obuffer[bufsize+1];
    bool outdata=false;

    while (socketopen) {
        unsigned long il,ol;
        int ret;
        if((ret=SSL_read_ex(ssl, ibuffer, bufsize, &il))>0){
            send(sock, ibuffer, il, 0);
        }else {
            int err=SSL_get_error(ssl, ret);
            if (!(err == SSL_ERROR_WANT_READ || err == SSL_ERROR_WANT_WRITE)) {
                break;
            }
        }

        if((ret=recv(sock, obuffer, bufsize, MSG_DONTWAIT))>0){
            SSL_write(ssl, obuffer, ret);
        }else{
            if(errno!=EAGAIN){
                break;
            }
        }

        usleep(25000);
        
    }
}